# BPpy: Behavioral Programming In Python
A Python implementation for the Behavioral Programming paradigm

## Installation
You can install ``bppy`` with pip:

```shell
pip install bppy
```

This does not include dependencies for gym integration. To install ``bppy`` with gym integration, use:

```shell
pip install bppy[gym]
```

If installation is not working, you can try upgrading pip:

```shell
pip install --upgrade pip
```

before submitting an issue.

In case you want to get started instantly and use ``bppy`` (with ``pynusmv`` and all dependencies) without installing it, you can use the [docker image](https://hub.docker.com/r/tomyaacov/bppy-docker):

```shell
docker run -it tomyaacov/bppy-docker
```


## Documentation
* [BPpy documentation](https://bppy.readthedocs.io/en/latest/)
* General introduction to Behavioral Programming can be found in [this](https://bpjs.readthedocs.io/en/develop/) BPjs tutorial and others

## Citing BPpy
To cite this repository in publications:
```
@misc{bppy,
  author = {Tom Yaacov},
  title = {BPpy: Behavioral Programming In Python},
  year = {2020},
  publisher = {GitHub},
  journal = {GitHub repository},
  howpublished = {\url{https://github.com/bThink-BGU/BPpy}},
}
```
